{==}
procedure NewLostKey(type_:word;self_,ind1_,ind2_:longint);
var p,p1,q:PLostKey;
begin
 p:=pLK;
 if p<>nil then
  if p^.next<>nil then begin
   if p^.next^.prev<>p then begin
    writeln('*** memory error',PALongInt(p^.next)^[1]);
   end;
  end;
  while(p<>nil)
   and(p^.Self<>self_)do begin
    q:=p;
    p:=p^.Next;
  end;
 if p<>nil then begin
  if(ind1_=-1)and(ind2_=-1)then inc(p^.ChildCount)
  else begin
   if ind1_<>-1 then p^.Index1:=ind1_;
   if ind2_<>-1 then p^.Index2:=ind2_;
  end;
 end else begin
  p:=pLK;
  if p<>nil then while p^.Next<>nil do p:=p^.Next;
  p1:=MemAlloc(SizeOf(TLostKey));
  if p1<>nil then begin
   if p=nil then pLK:=p1 else p^.Next:=p1;
   with p1^ do begin
    Prev:=p;
    Next:=nil;
    Self:=self_;
    NodeType:=type_;
    Parent:=-1;
    Index1:=ind1_;
    Index2:=ind2_;
    if(ind1_=-1)and(ind2_=-1)then
     ChildCount:=1 else ChildCount:=0;
    case type_ of
     h_nk:begin
           Min:=$50;
           Max:=$460;
          end;
     h_sk:begin
           Min:=$50;
           Max:=$1000;
          end;
     h_li:begin
           Min:=8;
           Max:=$1000;
          end;
    end;{case}
   end;
  end;
 end;
end;

{procedure NewLostParent(self_,parent_:longint);
var p,p1,q:PLostParent;
begin
 p1:=MemAlloc(SizeOf(TLostParent));
 if p1<>nil then begin
  p:=pLP;
  if p=nil then pLP:=p1 else begin
   while p^.Next<>nil do begin
    q:=p;
    p:=p^.Next;
   end;
   p^.Next:=p1;
  end;
  with p1^ do begin
   Prev:=p;
   Next:=nil;
   Self:=self_;
   Parent:=parent_;
   Index1:=-1;
   Index2:=-1;
  end;
  NewLostKey(parent_);
 end;
end;}

procedure CheckLostKeySize;
var p,q:PlostKey;
    L:longint;
begin
 if pLK<>nil then begin
  p:=pLK;
  while p<>nil do begin
   q:=pLK;
   while q<>nil do begin
    if p<>q then begin
     L:=q^.Self;
     with p^ do if(Self<L)and(Self+Max>L)then Max:=L-Self;
    end;
    q:=q^.Next;
   end;
   p:=p^.Next;
  end;
 end;
end;

procedure FreeLostKey;
var p:PLostKey;
begin
 p:=pLK;
 if p<>nil then begin
  while p^.Next<>nil do p:=p^.next;
  while p^.Prev<>nil do begin
   p:=p^.Prev;
   MemFree(p^.Next);
  end;
  MemFree(pLK);
 end;
end;

(*procedure FreeLostParent;
var p:PLostParent;
begin
 p:=pLP;
 if p<>nil then begin
  while p^.Next<>nil do p:=p^.next;
  while p^.Prev<>nil do begin
   p:=p^.Prev;
   MemFree(p^.Next);
  end;
  MemFree(pLP);
 end;
end;*)

procedure PrintLostKey;
var p:PLostKey;
    s:string;
begin
 p:=pLK;
 if(p<>nil)then begin
  s:='*** following blocks can be restored';
  writeln(log,s);writeln(s);
  while(p^.Prev<>nil)do p:=p^.Prev;
  while p<>nil do with p^ do begin
   s:=asStr(@p^.NodeType,2);
   s:=HexStr(Self+$1000,4)+' '+s+' cnt:'
     +HexStr(ChildCount,4)+'h MaxLen:'+HexStr(Max,4)+'h';
   if Index1<>-1 then s+=' ind1:'+HexStr(Index1+$1000,4)+'h';
   if Index2<>-1 then s+=' ind2:'+HexStr(Index2+$1000,4)+'h';
   if(NodeType=h_nk)and(Index1=-1)and((Self=Head.Offs)
      or((Head.Offs<$20)or(Head.Offs>Head.DataSize-$20)))
      then s+=' may be root!';
   writeln(log,s);writeln(s);
   p:=p^.Next;
  end;
 end;
end;

(*procedure PrintLostParent;
var p:PLostParent;
begin
 writeln('LostParent');
 p:=pLP;
 if(p<>nil)then while(p^.Prev<>nil)do p:=p^.Prev;
 while p<>nil do with p^ do begin
  writeln('Self: '+HexStr(Self,4)+'h Parent: '+HexStr(Parent,4)+'h');
  p:=p^.Next;
 end;
end;*)
