{==}
Const {Header1   }h_regf = $66676572; {'regf'}
      {Header2   }h_hbin = $6E696268; {'hbin'}
      {SubHeader1}h_lf = $666C;     {'lf'}
      {SubHeader8}h_lh = $686C;     {'lh'}
      {SubHeader2}h_nk = $6B6E;     {'nk'}
      {SubHeader3}h_sk = $6B73;     {'sk'}
      {SubHeader4}h_vk = $6B76;     {'vk'}
      {SubHeader9}h_db = $6264;     {'db'}
      {SubHeader5}h_ri = $6972;     {'ri'}
      {SubHeader6}h_li = $696C;     {'li'}
      {SubHeader7}h_lk = $696E;     {'lk'}

      MinBuffSize = $1000;
      MaxBuffSize = $F000;

      cReg9x = 98; cRegNT = 3; cReg2K = 4; cRegXP = 5;

      Space = '                                                        ';

      HbinStep = $1000;
      BlockStep = 4;

Type NTHeader = Record
            Head:Longint;
            Seq1,Seq2,H03,H04,H05,RegVer,
            H07,H08,Offs,DataSize,H11:Longint;
            Garbage:array[1..$80-13] of LongInt;
            CheckSum:LongInt;
     End;

     PNThbin = ^NThbin;
     NThbin = Record
            Head:LongInt;
            Offs:LongInt;
            Size:LongInt;
            w1,w2,w3,w4:word;
            L1,L2,SizeRes:LongInt;
     End;

     PNTSubHeader=^NTSubHeader;
     NTSubHeader = Record
            NodeSize:LongInt;
            NodeType:word;
     End;

     PNTNode=^NTNode;
     NTNode = Record
            NodeSize:LongInt;
            NodeType:word;
            flag:word;
            TimeStamp:Double;
            L1:LongInt;
            Parent:LongInt;
            ChildCount:LongInt;
            VChildCount:LongInt;
            PChildIndex:LongInt;
            VPChildIndex:LongInt;
            ParCount:LongInt;
            PParIndex:LongInt;
            PSec:LongInt;
            PClass:LongInt;
            L4,L5,L6,L7,L8:LongInt;
            NodeNameSize:word;
            ClassNameSize:word;
            NodeName:Byte;
     End;

     PNTPar=^NTPar;
     NTPar = Record
            NodeSize:LongInt;
            NodeType:word;
            ParNameSize:word;
            ValueSize:LongInt;
            PValue:LongInt;
            ParType:LongInt;
            w1,w2:word;
            ParName:Byte;
     End;

     PNTSec=^NTSec;
     NTSec = Record
            NodeSize:LongInt;
            NodeType,w1:word;
            PrevSK,NextSK,CountNK,SDSize:LongInt;
     End;

     PSecDescr = ^Security_Descriptor;
     Security_Descriptor = Record
            Rev,Sbz:Byte;
            Control:Word;
            Owner,Group,Sacl,Dacl:LongInt;
     End;

     PACL = ^TACL;
     TACL = Record
            Rev,Sbz1:Byte;
            ACLSize,ACECount,Sbz2:Word;
     End;

     PACE = ^TACE;
     TACE = Record
            ACEType,ACEFlag:Byte;
            ACESize:Word;
            AccessMask,SID:LongInt;
     End;

     PNode = ^TNode;
     TNode = Record
             Prev,Next:Pointer;
             PName:^String;
             Color:Byte;
             PSelf:LongInt;  { ᪠ 㦭   室 }
             Parent:LongInt;
             ChildCount:LongInt;
             PChildIndex:LongInt;
             ParCount:LongInt;
             PParIndex:LongInt;
             Name:Byte;
     End;

     PPar  = ^TPar;
     TPar  = Record
             Prev,Next:Pointer;
             PName:^String;
             Color:LongInt;
             Value:LongInt;
             ValSize:LongInt;
             Self:LongInt;
             Name:Byte;
     End;

     PVal  = ^TVal;
     TVal  = Record
             Prev,Next:Pointer;
             PName:^String;
             Color:LongInt;
             Name:Byte;
     End;

     PPath = ^TPath;
     TPath = Record
             Prev,Next:Pointer;
             PName:^String;
             Color:Byte;
             Name:Byte;
     End;

     InfoNT = Record
              Size,MaxSize,Count,Checksum:LongInt;
     End;

     PExpPath = ^ExpPath;
     ExpPath = Record
         Next,Prev:PExpPath;
         Name:Byte;
     End;
     PString = ^String;

{============================================}
(* PLostParent = ^TLostParent;
 TLostParent = record {  ﭭ묨 த⥫ﬨ}
  Prev,Next:PLostParent;
  Self,               {㪠⥫  ᥡ}
  Parent,             {㪠⥫  த⥫}
  Index1,             {㪠⥫  , 뫠騩   }
  Index2:longint;     {㪠⥫  , 뫠騩   }
 end; *)
{============================================}
 PLostKey = ^TLostKey;
 TLostKey = record {,    뫪}
  Prev,Next:PLostKey;
  Self:longint;       {㪠⥫  ᥡ}
  NodeType:word;      {⨯ }
  Parent,             {㪠⥫  த⥫}
  Index1,             {㪠⥫  , 뫠騩  ⮬}
  Index2:longint;     {㪠⥫  , 뫠騩   }
  ChildCount:longint; {⢮ 뫠 ⮬}
  Min,Max:longint;    {  ᨬ ࠧ }
 end;
{============================================}
